# Description
This migration populates the `principal_name` field for grants in the grants DynamoDB table.  It connects to Postgres to map login ID's to emails.  It then scans the DynamoDB table, and populates the `principal_name` field using either the corresponding email for a user, or the connector ID for connectors (this is just parsed from the URN which already exists in the grant's `principal` field).

The Migration should be run once the latest app/admin services and UI have been deployed.  Otherwise grants will continue to be added without the `principal_name` field populated.

# Steps to Run

- AWS must be configured on the jumphost for a user w/ dynamo permissions.  If your credentials are configured locally:

    `scp -r ~/.aws jump-{ENV_NAME}.ops.cbdtest.io:~`
- Move the scripts to the jumphost.  First navigate to the root dir of the repo.  Then:

    1: `tar -czvf principal-name-migration.tar.gz db/secops/migration/principal-name-migration`
    
    2: `scp principal-name-migration.tar.gz jump-{ENV_NAME}.ops.cbdtest.io:~`
- SSH into the jumpox and untar:

    1: `ssh -C -A {username}@jump-{ENV_NAME}.ops.cbdtest.io`
    
    2: `tar -xzf principal-name-migration.tar.gz`
    
    3: `cd db/secops/migration/principal-name-migration`
- Generate the `rds.json` file (this may need to be manually created on prodnrt):
   
   1: `/usr/local/scripts/bootstrap-decrypt.rb --secret rds.json.crypt --outfile rds.json`
   
- Run the script.  `source_env` should be the environment (eg. test03, prod01) and `dest_env` should be the hub env.
    
    `./principal-name-migration.sh {source_env} {dest_env}`
    
- Examine the `Grants without emails` output.  These represent user grants whose user principal's do not exist in the user Postgres table.

- Examing the `Conditional failure count` output.  The script must be rerun (no changes needed) until this value is `0`
    